import 'package:flutter/cupertino.dart';
import 'package:info_tren/components/cupertino_divider.dart';
import 'package:info_tren/pages/station_arrdep_page/select_station/select_station.dart';

class SelectStationPageStateCupertino extends SelectStationPageState {
  @override
  Widget build(BuildContext context) {
    return CupertinoPageScaffold(
      navigationBar: CupertinoNavigationBar(
        middle: Text(SelectStationPageState.pageTitle),
      ),
      child: SafeArea(
        bottom: false,
        child: Column(
          mainAxisSize: MainAxisSize.max,
          children: [
            Padding(
              padding: const EdgeInsets.all(4),
              child: CupertinoTextField(
                controller: textEditingController,
                autofocus: true,
                placeholder: SelectStationPageState.textFieldLabel,
                textInputAction: TextInputAction.search,
                onChanged: onTextChanged,
              ),
            ),
            Expanded(
              child: ListView.builder(
                itemBuilder: (context, index) {
                  return Column(
                    mainAxisSize: MainAxisSize.min,
                    crossAxisAlignment: CrossAxisAlignment.stretch,
                    children: [
                      GestureDetector(
                        child: Padding(
                          padding: const EdgeInsets.all(8.0),
                          child: Text(filteredStations[index]),
                        ),
                        onTap: () => onSuggestionSelected(filteredStations[index]),
                      ),
                      CupertinoDivider(),
                    ],
                  );
                },
                itemCount: filteredStations.length,
              ),
            ),
          ],
        ),
      ),
    );
  }
}
